/// <reference types="react" />
import type { GraphQLError } from 'graphql';
type RequestDetails = {
    query: string;
    operationName: string;
    operationKind: string;
    variables: any;
};
interface EnhancedGqlError extends GraphQLError {
    __RedwoodEnhancedError: RequestDetails;
}
type ErrorWithRequestMeta = Error & {
    mostRecentRequest?: RequestDetails;
    graphQLErrors: EnhancedGqlError[];
    mostRecentResponse?: any;
};
export declare const DevFatalErrorPage: (props: {
    error?: ErrorWithRequestMeta;
}) => import("react").JSX.Element;
export {};
//# sourceMappingURL=DevFatalErrorPage.d.ts.map