"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = require("react-dom");
var _ServerInject = require("./ServerInject");
function addDataAttributeMarker(children) {
  var _context;
  let marker = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'data-rwjs-head';
  return (0, _map.default)(_context = _react.default.Children.toArray(children)).call(_context, (child, i) => {
    return /*#__PURE__*/_react.default.cloneElement(child, {
      [marker]: true,
      key: `${marker}-` + i
    });
  });
}
const PortalHead = _ref => {
  let {
    children
  } = _ref;
  const isServerRendering = typeof window === 'undefined';
  (0, _ServerInject.useServerInsertedHTML)(() => {
    // Add "data-rwjs-head" attribute to anything inside <PortalHead>,
    // This is then later moved to the <head> in the final block of the transform stream (see streamHelpers.ts)
    return addDataAttributeMarker(children);
  });

  // shouldPortal is always false on hard render. Because we use a ref,
  // the value change is not detected by React and the component is not re-rendered (intentionally)
  // On a soft render, the value is always true. This is all to prevent double rendering of the head elements.

  // @TODO
  // There is an edgecase: if you change the children inside <PortalHead> after a hard render, it will not be reflected.
  // Workaround: don't change children, render a new portal head: x ? <PH>aaa</PH> : <PH>bbb</PH>
  // we may want to look at using a callback ref: https://shrtm.nu/gMx
  const shouldPortal = _react.default.useRef(isServerRendering ? false : document.readyState === 'complete');
  if (isServerRendering) {
    // Don't do anything on the server, handled by useServerInsertedHTML
    return null;
  } else {
    // On hard render, don't do anything on the client. On soft render, portal to <head>
    return shouldPortal.current ? /*#__PURE__*/(0, _reactDom.createPortal)(children, document.head) : null;
  }
};
var _default = exports.default = PortalHead;