"use strict";
'use client';

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.CellErrorBoundary = void 0;
var _react = _interopRequireDefault(require("react"));
class CellErrorBoundary extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      hasError: false
    };
  }
  static getDerivedStateFromError(error) {
    return {
      hasError: true,
      error
    };
  }
  componentDidCatch(error, errorInfo) {
    // @TODO do something with this?
    console.log('Cell failure: ', {
      error,
      errorInfo
    });
  }
  render() {
    // The fallback is constructed with all the props required, except error and errorCode
    // in createSuspendingCell.tsx
    const {
      renderFallback
    } = this.props;
    if (this.state.hasError) {
      return renderFallback({
        error: this.state.error,
        resetErrorBoundary: () => {
          this.setState({
            hasError: false,
            error: undefined
          });
        }
      });
    }
    return this.props.children;
  }
}
exports.CellErrorBoundary = CellErrorBoundary;