/// <reference types="react" />
/** CSS is a specialised metatag */
export declare const Css: ({ css }: {
    css: string[];
}) => import("react").JSX.Element;
/**
 * <title>My Page</title>
 */
interface Title {
    title: string;
}
/**
 * <meta name="author" content="Chris Mills" />
 */
interface NameContent {
    name: string;
    content: string;
}
/**
 * <meta property="og:image"
 * content="https://.../opengraph-logo.png" />
 */
interface OpenGraph {
    property: string;
    content: string;
}
/**
 * <meta http-equiv="refresh" content="30">
 */
interface HttpEquiv {
    httpEquiv: string;
    content: string;
}
/***
 * <meta some-attribute="some-value" />
 */
interface Custom {
    [name: string]: unknown;
}
/**
 * <link rel="canonical" href="https://example.com" />
 */
interface Other extends Custom {
    tagType: string;
}
export type TagDescriptor = Title | NameContent | OpenGraph | HttpEquiv | Custom | Other;
interface MetaProps {
    tags: TagDescriptor[] | undefined;
}
export declare const Meta: ({ tags }: MetaProps) => import("react").JSX.Element;
export {};
//# sourceMappingURL=htmlTags.d.ts.map