"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.Meta = exports.Css = void 0;
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/starts-with"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));
var _react = require("react");
var _jsxRuntime = require("react/jsx-runtime");
const extractFromAssetMap = key => {
  if (typeof window !== 'undefined') {
    return window?.__REDWOOD__ASSET_MAP?.[key];
  }
  return null;
};
function addSlashIfNeeded(path) {
  if ((0, _startsWith.default)(path).call(path, 'http') || (0, _startsWith.default)(path).call(path, '/')) {
    return path;
  } else {
    return '/' + path;
  }
}

/** CSS is a specialised metatag */
const Css = _ref => {
  var _context;
  let {
    css
  } = _ref;
  const cssLinks = (0, _map.default)(_context = css || extractFromAssetMap('css') || []).call(_context, addSlashIfNeeded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_jsxRuntime.Fragment, {
    children: (0, _map.default)(cssLinks).call(cssLinks, (cssLink, index) => {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("link", {
        rel: "stylesheet",
        href: `${cssLink}`
      }, `css-${index}`);
    })
  });
};

/**
 * <title>My Page</title>
 */

/**
 * <meta name="author" content="Chris Mills" />
 */

/**
 * <meta property="og:image"
 * content="https://.../opengraph-logo.png" />
 */

/**
 * <meta http-equiv="refresh" content="30">
 */

/***
 * <meta some-attribute="some-value" />
 */

/**
 * <link rel="canonical" href="https://example.com" />
 */

// @MARK Maintaining a similar format to Remix's V2_MetaDescriptor
// 1. because I (Danny) like it
// 2. because it'll feel consistent to people who are familiar with Remix
// I've modified it a little bit, but we need to decide wether we want the
// remix style DIY meta tags, or the more opinionated approach in MetaTags.tsx
exports.Css = Css;
const Meta = _ref2 => {
  let {
    tags
  } = _ref2;
  const metaTags = tags || extractFromAssetMap('meta') || [];
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_jsxRuntime.Fragment, {
    children: (0, _map.default)(metaTags).call(metaTags, (tag, index) => {
      if (!tag) {
        return null;
      }
      if (isTitleTag(tag)) {
        return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react.Fragment, {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("title", {
            children: tag.title
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("meta", {
            property: "og:title",
            content: tag.title
          })]
        }, "title");
      }

      // TODO (STREAMING) add validate tag function
      if (otherTag(tag)) {
        const {
          tagType: TagName,
          ...rest
        } = tag;
        return /*#__PURE__*/(0, _jsxRuntime.jsx)(TagName, {
          ...rest
        }, `meta-${index}`);
      }
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("meta", {
        ...tag
      }, `meta-${index}`);
    })
  });
};
exports.Meta = Meta;
const isTitleTag = tag => {
  return 'title' in tag;
};

// Not a "<meta>" tag
const otherTag = tag => {
  return 'tagType' in tag;
};